# Closures and closures iterators

!!! warning
    This auditors' handbook is frozen and obsolete; the [Nim language manual](https://nim-lang.org/docs/manual.html) alongside [other Nim documentation](https://nim-lang.org/documentation.html), [Status Nim style guide](https://status-im.github.io/nim-style-guide/), [Chronos guides](https://github.com/status-im/nim-chronos/blob/master/docs/src/SUMMARY.md), and [Nim by Example](https://nim-by-example.github.io/getting_started/) supercede it.

TODO

## At a low-level

Closures and closures iterators are implemented via
a pointer + an environment that stores the captured state necessary
to execute the function.

The Nim compiler has a limited form of borrow checking and prevents
capturing mutable variable or openArray (pointer+length pair).

It otherwise copies the capture variables in case of objects with value semantics
or increment the reference count in case of ref object.

The Chronos library needs to generate a closure iterator for all async proc instantiated
which may lead to long-lived ref objects and unreclaimable memory.

This may also extend to other resources like socket connections or file descriptors and
a significant effort is underway to track memory usage and detect such scenarios:

- [https://github.com/status-im/nim-libp2p/issues/145](https://github.com/status-im/nim-libp2p/issues/145)
- [https://github.com/status-im/nim-libp2p/issues/207](https://github.com/status-im/nim-libp2p/issues/207)
