# Generics and Static types

!!! warning
    This auditors' handbook is frozen and obsolete; the [Nim language manual](https://nim-lang.org/docs/manual.html) alongside [other Nim documentation](https://nim-lang.org/documentation.html), [Status Nim style guide](https://status-im.github.io/nim-style-guide/), [Chronos guides](https://github.com/status-im/nim-chronos/blob/master/docs/src/SUMMARY.md), and [Nim by Example](https://nim-by-example.github.io/getting_started/) supercede it.

Nim types can be parametrized by types (generics) or compile-time values (static)

For example

```Nim
type
  MySeq[T] = object
    len, reserved: int
    data: ptr UncheckedArray[T]
```

The generics can be restricted

```Nim
type
  MySeq[T: int32 or int64] = object
    len, reserved: int
    data: ptr UncheckedArray[T]
```

With static types

```Nim
type
  SmallSeq[MaxLen: static int, T] = object
    len: int
    data: array[MaxLen, T]
```
